import draw.*;
import colors.*;
import geometry.*;

import tester.*;

/**
 * Examples for the problem that deals with the US map
 * @author Viera K. Proulx
 * @since 20 March 2011
 *
 */
class ExamplesGraphAlgorithms{
  ExamplesGraphAlgorithms(){}
    
  City al = new City("36105", "Montgomery", "AL", 86, 32);
  City az = new City("85009", "Phoenix", "AZ", 112, 33);
  City ar = new City("72201", "Little Rock", "AR", 92, 35);
  City ca = new City("95819", "Sacramento", "CA", 121, 39);
  City co = new City("80204", "Denver", "CO", 105, 40);
  City ct = new City("06120", "Hartford", "CT", 73, 42);
  City de = new City("19901", "Dover", "DE", 76, 40);
  City fl = new City("32304", "Tallahassee", "FL", 84, 30);
  City ga = new City("30306", "Atlanta", "GA", 84, 34);
  City ia = new City("50314", "Des Moines", "IA", 94, 41);
  City id = new City("83705", "Boise", "ID", 116, 44);
  City il = new City("62701", "Springfield", "IL", 90, 40);
  City in = new City("46219", "Indianapolis", "IN", 86, 40);
  City ks = new City("66610", "Topeka", "KS", 96, 39);
  City ky = new City("40212", "Frankfort", "KY", 86, 38);
  City la = new City("70815", "Baton Rouge", "LA", 91, 30);
  City ma = new City("02115", "Boston", "MA", 71, 42);
  City md = new City("21403", "Annapolis", "MD", 76, 39);
  City me = new City("04330", "Augusta", "ME", 70, 44);
  City mi = new City("48823", "Lansing", "MI", 84, 43);
  City mn = new City("55103", "Saint Paul", "MN", 93, 45);
  City mo = new City("65101", "Jefferson City", "MO", 92, 39);
  City ms = new City("39209", "Jackson", "MS", 90, 32);
  City mt = new City("59635", "Helena", "MT", 112, 47);
  City nc = new City("27606", "Raleigh", "NC", 79, 36);
  City nd = new City("58501", "Bismarck", "ND", 101, 47);
  City ne = new City("68503", "Lincoln", "NE", 97, 41);
  City nh = new City("03301", "Concord", "NH", 72, 43);
  City nj = new City("08618", "Trenton", "NJ", 75, 40);
  City nm = new City("87505", "Santa Fe", "NM", 106, 36);
  City nv = new City("89704", "Carson City", "NV", 120, 39);
  City ny = new City("12207", "Albany", "NY", 74, 43);
  City oh = new City("43210", "Columbus", "OH", 83, 40);
  City ok = new City("73105", "Oklahoma City", "OK", 98, 36);
  City or = new City("97301", "Salem", "OR", 123, 45);
  City pa = new City("17101", "Harrisburg", "PA", 77, 40);
  City ri = new City("02908", "Providence", "RI", 71, 41);
  City sc = new City("29209", "Columbia", "SC", 81, 34);
  City sd = new City("57501", "Pierre", "SD", 100, 44);
  City tn = new City("37914", "Nashville", "TN", 84, 36);
  City tx = new City("78721", "Austin", "TX", 98, 30);
  City ut = new City("84103", "Salt Lake City", "UT", 112, 41);
  City va = new City("23222", "Richmond", "VA", 77, 38);
  City vt = new City("05602", "Montpelier", "VT", 73, 44);
  City wa = new City("98501", "Olympia", "WA", 123, 47);
  City wi = new City("53714", "Madison", "WI", 89, 43);
  City wv = new City("25301", "Charleston", "WV", 82, 38);
  City wy = new City("82001", "Cheyenne", "WY", 105, 41);

  
  ILoCity mtlocity = new MtLoCity();
  ILoCity usa = 
    new ConsLoCity(this.al,
    new ConsLoCity(this.az,
    new ConsLoCity(this.ar,
    new ConsLoCity(this.ca,
    new ConsLoCity(this.co,
    new ConsLoCity(this.ct,
    new ConsLoCity(this.de,
    new ConsLoCity(this.fl,
    new ConsLoCity(this.ga,
    new ConsLoCity(this.ia,
    new ConsLoCity(this.id,
    new ConsLoCity(this.il,
    new ConsLoCity(this.in,
    new ConsLoCity(this.ks,
    new ConsLoCity(this.ky,
    new ConsLoCity(this.la,
    new ConsLoCity(this.ma,
    new ConsLoCity(this.md,
    new ConsLoCity(this.me,
    new ConsLoCity(this.mi,
    new ConsLoCity(this.mn,
    new ConsLoCity(this.mo,
    new ConsLoCity(this.ms,
    new ConsLoCity(this.mt,
    new ConsLoCity(this.nc,
    new ConsLoCity(this.nd,
    new ConsLoCity(this.ne,
    new ConsLoCity(this.nh,
    new ConsLoCity(this.nj,
    new ConsLoCity(this.nm,
    new ConsLoCity(this.nv,
    new ConsLoCity(this.ny,
    new ConsLoCity(this.oh,
    new ConsLoCity(this.ok,
    new ConsLoCity(this.or,
    new ConsLoCity(this.pa,
    new ConsLoCity(this.ri,
    new ConsLoCity(this.sc,
    new ConsLoCity(this.sd,
    new ConsLoCity(this.tn,
    new ConsLoCity(this.tx,
    new ConsLoCity(this.ut,
    new ConsLoCity(this.va,
    new ConsLoCity(this.vt,
    new ConsLoCity(this.wa,
    new ConsLoCity(this.wi,
    new ConsLoCity(this.wv,
    new ConsLoCity(this.wy,  
        this.mtlocity))))))))))))))))))))))))))))))))))))))))))))))));
  
  ILoCity route = 
    new ConsLoCity(this.al,
    new ConsLoCity(this.ar,
    new ConsLoCity(this.az,
    new ConsLoCity(this.ca,
    new ConsLoCity(this.co,
    new ConsLoCity(this.ia,
    new ConsLoCity(this.il,
    new ConsLoCity(this.oh,
    new ConsLoCity(this.pa,
    new ConsLoCity(this.ny,
    new ConsLoCity(this.me,   
        this.mtlocity))))))))))); 

  
  boolean drawAll(){
    GraphWorld gw = new GraphWorld(this.usa, this.route);
    return gw.bigBang(400, 400, 0.1);    
  }
  
  
  void testDrawing(Tester t){
    Canvas c = new Canvas(400, 400);
    ILoCity temproute = this.route;
    c.show();
    this.usa.drawCities(c);
    // COMMENT: this would not be allowed in the functional style.
    // The value of the variable temproute changes as the method
    // is executed, and at the end it represents an empty list.
    // If we had used the original data, 'this.route', its value would 
    // have been destroyed by this test.
    // MUTATION BRINGS ON HEADACHES !!!
    temproute.drawNext(c);
    temproute = temproute.advance();
    temproute.drawNext(c);
    temproute = temproute.advance();
    temproute.drawNext(c);
    temproute = temproute.advance();
    temproute.drawNext(c);
    temproute = temproute.advance();
    temproute.drawNext(c);
    temproute = temproute.advance();
    temproute.drawNext(c);
    temproute = temproute.advance();
    temproute.drawNext(c);
    temproute = temproute.advance();
    temproute.drawNext(c);
    temproute = temproute.advance();
    temproute.drawNext(c);
    temproute = temproute.advance();
    temproute.drawNext(c);
    t.checkExpect(5 > 3, true);
  }
  
  
  void testGraphWorld(Tester t){
    t.checkExpect(5 > 3, true);
    this.drawAll();
  }


  // run the program/tests directly
  public static void main(String[] argv){
    ExamplesGraphAlgorithms e = new ExamplesGraphAlgorithms();
    Tester.runReport(e, true, true);
    
  }
}
  
